# MUSH 2021

## What is MUSH 2021

MUSH 2021 is a modern take on MUSH servers, which where a popular text only multiplayer online platform system allowing for the creation of various role playing and casual game and social systems.  What made MUSH unique was it's object based in game creation model which allowed for the creation of any world or worlds one could imagine.  The idea with this project is to that that original concept of unlimited imagination and bring it to a more modern realization.   The primary interface to this modern MUSH will be the web browser, this will allow for a rich experience using modern HTML, CSS, and Javascript for client side UI, and utilize websockets for direct server connection.  MUSH 2021 will use LUA as the in game scripting language allowing for a full creation of the world from within.

## Current State of Development

MUSH 2021 is currently in the very beginning idea / tinkering stage.  This means that I have started a base code project, and started to experiment with ideas on how I wish to create the MUSH engine and operate the core mechanics.   I wish for this to be an open source project from the very beginning and so hence why I am even bothering to mention this so early on.

Please note that at this state of development if you see this README with this text that means you are looking at this code very early on, so anything you see is highly subject and likely to change :).

## Building

### Dependancies

* UV
* pthreads
* MySQL client

### Compiling

The root folder of the project contains a Makefile, currently there are only 2 rules:

* MUSH2021 - Build the server
* clean - delete mush2021 binary

### Changelog

#### Version: 0.0.1
This is the very first version!  This version fleshes out the beginning skeleton of the project and the base core ideas that will be the foundation of MUSH2021.

## License

              __  _____  _______ __  _____   ____ ___  ___
             /  |/  / / / / ___// / / /__ \ / __ \__ \<  /
            / /|_/ / / / /\__ \/ /_/ /__/ // / / /_/ // / 
           / /  / / /_/ /___/ / __  // __// /_/ / __// /  
          /_/  /_/\____//____/_/ /_//____/\____/____/_/   
                                                          
    Copyright (C) 2021  MatCat

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

MUSH 2021 uses the GNU General Public License v3.0, please see the file LICENSE for complete text of the license.
