/*
              __  _____  _______ __  _____   ____ ___  ___
             /  |/  / / / / ___// / / /__ \ / __ \__ \<  /
            / /|_/ / / / /\__ \/ /_/ /__/ // / / /_/ // / 
           / /  / / /_/ /___/ / __  // __// /_/ / __// /  
          /_/  /_/\____//____/_/ /_//____/\____/____/_/   

    Copyright (C) 2021  MatCat

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/

#include <string>
#include <cstdint>

class VariableVector {
    public:
        std::string Name;
        std::string Value; // TODO: Template this for different types
};

class BaseObject {
    public:
        uint64_t ID;
        std::string Name;
        BaseObject *Container;
        std::vector<VariableVector> Variables;

        void printName();
        void SetVariable(std::string var, std::string val);
        std::string getVariable(std::string var);
};

class UserObject: public BaseObject {
    public:
        std::string Password;
        void printUserInfo();
};

class ObjectVector {
    public:
        uint64_t ID;
        BaseObject *Object;
};
